(load "clos.cl")

(defclass model ()
   ((dependents         :accessor model-dependents
                        :initform '())
    (maximum-dependents :allocation :class
                        :accessor model-maximum
                        :initform 10)
   ))

(defmethod add-dependent ((receiver model) (watcher view))
   (if (< (length (model-dependents receiver)) (model-maximum receiver))
       (setf (model-dependents receiver)
             (append (model-dependents receiver) (list watcher)))
       (format t "I already have too many dependents!")
   ))

(defmethod change ((receiver model))
   (mapcar #'(lambda (dependent) (update dependent))
           (model-dependents receiver))
   )
