package Reactor is

   Max_Dependents : constant := 10;

   type String_Ptr   is access String;

   type Reactor_Type (Name : String_Ptr) is private;
   type Reactor_Ptr  is access Reactor_Type;


   procedure Add_Dependent (Model : in  Reactor_Ptr;
                            View  : in  Reactor_Ptr);

   procedure Change (Model : in Reactor_Ptr);

   procedure Update (View   : in Reactor_Ptr;
                     Sender : in Reactor_Ptr);

private
   subtype Count_Range is Integer     range 0..Max_Dependents;
   subtype Index_Range is Count_Range range 1..Max_Dependents;

   type Reactor_Array is array (Index_Range) of Reactor_Ptr;

   type Reactor_Type (Name : String_Ptr) is
      record
         Dependents     : Reactor_Array;
         Num_Dependents : Count_Range    := 0;
      end record;
end Reactor;
